-- ForteXorcist v1.957 by Xus 13-01-2010

FW = {}; -- core table
FC_Saved = {}; -- save table
--local FC_Saved = FC_Saved; -- iz bad mkay!
local FW_Debug = false;
local FW = FW;
FW.L = {}; -- locale table
local FWL = FW.L;
FW.Default = {};

FW.Frames = {};

local FC_UpdateFrame;
local Commands = {};

local FW_Events = {};
local FW_Timed = {};
local FW_Loaded = {};
local FW_DelayedLoaded = {};
local FW_VariablesLoaded = {};
local FW_Updated = {};
local FW_Messages = {};
local FW_oRAMessages = {};
local FW_EnterPartyRaid = {};
local FW_OnEnterCombat = {};
local FW_OnLeaveCombat = {};

local FilterRefresh = {};

local strfind = strfind;
local strformat = string.format;
local ipairs = ipairs;
local pairs = pairs;
local unpack = unpack;
local select = select;
local GetTime = GetTime;
local type = type;
local _G = _G;

FW.TITLE = "ForteXorcist";
local VERSION = "v1.957";
local PREFIX = "ForteWarlock";
local ENABLE = false;

local isMine = {["player"]=true,["pet"]=true,["vehicle"]=true};

local CustomIDToName = {};
local CustomNameToID = {};

local origUnitBuff = UnitBuff;
local origUnitDebuff = UnitDebuff;

FW.UnitBuff = function(unit,buff,rank,filter) -- works exactly like the original, but takes custom names into account
	if type(buff) == "string" then
		local id = CustomNameToID[buff];
		if id then
			local i = 1;
			while true do
				local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = origUnitBuff(unit,i,filter);
				if name then
					if id == spellId then
						return buff, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId;
					end
					i=i+1;
				else
					return nil;
				end
			end
		else
			return origUnitBuff(unit,buff,rank,filter);
		end
	else
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = origUnitBuff(unit,buff,rank,filter);
		return CustomIDToName[spellId] or name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId;
	end
end

FW.UnitDebuff = function(unit,buff,rank,filter) -- works exactly like the original, but takes custom names into account
	if type(buff) == "string" then
		local id = CustomNameToID[buff];
		if id then
			local i = 1;
			while true do
				local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = origUnitDebuff(unit,i,filter);
				if name then
					if id == spellId then
						return buff, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId;
					end
					i=i+1;
				else
					return nil;
				end
			end
		else
			return origUnitDebuff(unit,buff,rank,filter);
		end
	else
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = origUnitDebuff(unit,buff,rank,filter);
		return CustomIDToName[spellId] or name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId;
	end
end
	
local UnitBuff = FW.UnitBuff;
local UnitDebuff = FW.UnitDebuff;

local origUnitName = UnitName;
FW.FullUnitName = function(token)
	local name, realm = origUnitName(token);
	if realm and realm~="" then
		return name.."-"..realm;
	else
		return name;
	end
end
local UnitName = FW.FullUnitName;

FW.Sets = {};

FW.BORDER = 3;
--FW.pet,target,focus is also non-nil (guid) when present
FW.PLAYER = UnitName("player");
FW.CLASS = select(2,UnitClass("player"));
FW.SERVER = GetRealmName();
FW.RACE = select(2,UnitRace("player"));

FW.ID_SOULSHARD = 6265;
FW.ID_SOULSTONE = {
	5232,
	16892,
	16893,
	16895,
	16896,
	22116,
	36895,
};

FW.ORA_SHARD_REQUEST = "ITMC "..FW.ID_SOULSHARD;
FW.ORA_ITEM_RESPONSE = "ITM ([%d%-]+) (%d+)";
FW.ORA_ITEM_RESPONSE_SHORT = "ITM %s %s %s";
FW.ORA_ITEM_REQUEST_SHORT = "ITMC ";
FW.ORA_ITEM_REQUEST = "ITMC (%d+)$";

FW.PARTY = {};for i=1,4,1 do tinsert(FW.PARTY,"party"..i);end
local PARTY = FW.PARTY;
FW.RAID = {};for i=1,40,1 do tinsert(FW.RAID,"raid"..i);end
local RAID = FW.RAID;

FW.OPTION_COLOR = {};
FW.OPTION_COLOR.CLASS = {RAID_CLASS_COLORS[FW.CLASS].r,RAID_CLASS_COLORS[FW.CLASS].g,RAID_CLASS_COLORS[FW.CLASS].b};
FW.OPTION_COLOR.COOLDOWN = {0.00,1.00,0.50};
FW.OPTION_COLOR.TIMER = {1.00,0.50,0.00};

FW.OPTION_COLOR.SOULSTONE = {0.55,0.00,0.70};
FW.OPTION_COLOR.SHARD = {0.55,0.00,0.70};
FW.OPTION_COLOR.HEALTHSTONE = {0.00,1.00,0.00};
FW.OPTION_COLOR.SHARDMANAGER = {0.55,0.00,0.70};
FW.OPTION_COLOR.SUMMON = {0.55,0.00,0.70};
FW.OPTION_COLOR.TALENT = {1.00,0.00,0.00};

FW.OPTION_COLOR.RAIDMESSAGES = {0.00,0.50,1.00};
FW.OPTION_COLOR.SELFMESSAGES = {0.00,0.50,1.00};
FW.OPTION_COLOR.SOUND = {0.00,0.50,1.00};
FW.OPTION_COLOR.ABOUT = {1.00,1.00,0.00};

FW.FLAG_RES = 0; -- can res with ss
FW.FLAG_DI = 1; -- is di-ed
FW.FLAG_TIME = 2; -- normal soulstone duration
FW.FLAG_WARLOCK = 3;
FW.FLAG_DRUID = 4;
FW.FLAG_PALADIN = 5;
FW.FLAG_SHAMAN = 6;

FW.FLAG_NORMAL = 0;
FW.FLAG_UNKNOWN = 1;
FW.FLAG_DEAD = 2;
FW.FLAG_OFFLINE = 3;

FW.FILTER_ALWAYS = 3;
FW.FILTER_SHOW = 1;
FW.FILTER_NONE = 0;
FW.FILTER_HIDE = -1;
FW.FILTER_COLOR = -2;
FW.FILTER_SHOW_COLOR = 2;

-- spell timer flags
FW.DEFAULT = 1;
FW.SHARED = 2;
FW.UNIQUE = 3;
-- above are scanned by standard as debuff
FW.PET = 4;
FW.POWERUP = 5;
FW.SELF_DEBUFF = 6;
FW.CHARM = 7;
FW.COOLDOWN = 8;
FW.DEBUFF = 9;
FW.DRAIN = 10;
-- below are scanned by standard as buff
FW.HEAL = 11;
FW.BUFF = 12;

FW.LAST_TIMER_FLAG = FW.BUFF;

FW.PRIOR_COOLDOWN = 0;
FW.PRIOR_NONE = -1;
FW.PRIOR_DEBUFF = -2;
FW.PRIOR_SELF_DEBUFF = -3;
FW.PRIOR_POWERUP = -4;

FW.RaidIcons = {"{rt1}","{rt2}","{rt3}","{rt4}","{rt5}","{rt6}","{rt7}","{rt8}"};

FW.FontList = {};
FW.SoundList = {};
FW.BorderList = {};
FW.BackgroundList = {};

--[[function FW:RT(val,roundto)
	FW:Show(tostring(FW:RoundTo(val,roundto)));
end]]

function FW:RoundTo(val,roundto)
	if not roundto or roundto <= 0 then
		return val;
	end
	local f = 100;
	val = f*val;
	roundto = f*roundto;
	
	local remain = val%roundto;
	val = val - remain;
	if remain >= roundto*0.5 then
		return (val + roundto)/f;
	elseif remain < -roundto*0.5 then
		return (val - roundto)/f;
	else
		return val/f;
	end
end

function FW:Show(msg,r,g,b,a) DEFAULT_CHAT_FRAME:AddMessage(msg,r,g,b,a); end

function FW:ShowDebug(msg) if FW_Debug then FW:Show("Debug: "..msg,1,0.5,0); end end

function FW:RegisterFont(path,name)
	tinsert(FW.FontList,{path,name});
end

function FW:RegisterBorder(path,name)
	tinsert(FW.BorderList,{path,name});
end

function FW:RegisterBackground(path,name)
	tinsert(FW.BackgroundList,{path,name});
end

function FW:RegisterSound(path,name)
	tinsert(FW.SoundList,{path,name});
end

function FW:SetDefaultFont(path,size)
	FW.Default.Font = path;
	FW.Default.FontSize = size;
end

FW.ERASE = function(t) -- erases any table
	for k in pairs(t) do
		if type(t[k])=="table" then
			FW.ERASE(t[k]);
		end
		t[k]= nil;
	end
end
local erase = FW.ERASE;

FW:RegisterFont("Fonts\\ARIALN.TTF", "Arial Narrow");
FW:RegisterFont("Fonts\\FRIZQT__.TTF", "Friz Quadrata TT");
FW:RegisterFont("Fonts\\MORPHEUS.TTF", "Morpheus");
FW:RegisterFont("Fonts\\SKURRI.TTF", "Skurri");
FW:RegisterFont("Interface\\AddOns\\Forte_Core\\Fonts\\FORTE.TTF", "Forte");
FW:RegisterFont("Interface\\AddOns\\Forte_Core\\Fonts\\HandelGothicBT.TTF", "Handel Gothic BT");
FW:RegisterFont("Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF", "Century Gothic");
FW:RegisterFont("Interface\\AddOns\\Forte_Core\\Fonts\\GOTHICB.TTF", "Century Gothic Bold");
FW:SetDefaultFont("Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF", 11);

FW:RegisterBorder("None", "None");
FW:RegisterBorder("Interface\\AddOns\\Forte_Core\\Textures\\Border", "ForteXorcist");

FW:RegisterBackground("None", "None");
FW:RegisterBackground("Interface\\AddOns\\Forte_Core\\Textures\\Background", "ForteXorcist");
FW:RegisterBackground("Interface\\AddOns\\Forte_Core\\Textures\\Otravi", "Otravi");
FW:RegisterBackground("Interface\\AddOns\\Forte_Core\\Textures\\Smooth", "Smooth");

FW:RegisterSound("Interface\\AddOns\\Forte_Core\\Sounds\\SoulstoneExpire.mp3", "FX: Soulstone Expire");
FW:RegisterSound("Sound\\Spells\\SoulstoneResurrection_Base.wav","Soulstone");
FW:RegisterSound("Sound\\Spells\\EnlargeCast.wav","Enlarge");
FW:RegisterSound("Sound\\Spells\\FluteRun.wav","Flute");
FW:RegisterSound("Sound\\Spells\\ShadowWard.wav","Shadow Ward");
FW:RegisterSound("Sound\\Spells\\ShadowWordSilence.wav","Silence");
FW:RegisterSound("Sound\\Spells\\ShadowWordPain_Chest.wav","Shadow Word Pain");
FW:RegisterSound("Sound\\Spells\\ShadowWordFumble.wav","Fumble");
FW:RegisterSound("Sound\\Spells\\AntiHoly.wav","Anti Holy");
FW:RegisterSound("Sound\\Spells\\Bonk1.wav","Bonk1");
FW:RegisterSound("Sound\\Spells\\Bonk2.wav","Bonk2");
FW:RegisterSound("Sound\\Spells\\Bonk3.wav","Bonk3");
FW:RegisterSound("Sound\\Spells\\consume_magic_impact.wav","Consume Magic");
FW:RegisterSound("Sound\\Spells\\Creature_SpellPortalLarge_All_Colors.wav","Spell Portal");
FW:RegisterSound("Sound\\Spells\\Ingvar_ResurrectionGroundVisual.wav","Resurrection Ground");
FW:RegisterSound("Sound\\Spells\\Resurrection.wav","Resurrection");
FW:RegisterSound("Sound\\Spells\\Rogue_shadowdance_state.wav","Shadow Dance");
FW:RegisterSound("Sound\\Spells\\ShaysBell.wav","Shay's Bell");
FW:RegisterSound("Sound\\Spells\\SimonGame_Visual_BadPress.wav","Simon Error");
FW:RegisterSound("Sound\\Spells\\SimonGame_Visual_GameFailedLarge.wav","Simon Failed Large");
FW:RegisterSound("Sound\\Spells\\SimonGame_Visual_GameFailedSmall.wav","Simon Failed Small");
FW:RegisterSound("Sound\\Spells\\SimonGame_Visual_GameStart.wav","Simon Start");
FW:RegisterSound("Sound\\Spells\\SimonGame_Visual_GameTick.wav","Simon Tick");
FW:RegisterSound("Sound\\Spells\\SimonGame_Visual_LevelStart.wav","Simon Level Start");

FW.TextureList = {
		"Interface\\AddOns\\Forte_Core\\Textures\\Aluminium",
		"Interface\\AddOns\\Forte_Core\\Textures\\Minimalist",
		"Interface\\AddOns\\Forte_Core\\Textures\\Xus",
		"Interface\\AddOns\\Forte_Core\\Textures\\Otravi",
		"Interface\\AddOns\\Forte_Core\\Textures\\LiteStep",
		"Interface\\AddOns\\Forte_Core\\Textures\\BantoBar",
		"Interface\\AddOns\\Forte_Core\\Textures\\Charcoal",
		"Interface\\AddOns\\Forte_Core\\Textures\\Perl",
		"Interface\\AddOns\\Forte_Core\\Textures\\Smooth",
		"Interface\\AddOns\\Forte_Core\\Textures\\Smudge",
		"Interface\\AddOns\\Forte_Core\\Textures\\Striped",
		"Interface\\AddOns\\Forte_Core\\Textures\\Glaze",
		"Interface\\AddOns\\Forte_Core\\Textures\\Frost",
		"Interface\\AddOns\\Forte_Core\\Textures\\HealBot",
		"Interface\\AddOns\\Forte_Core\\Textures\\Rocks",
		"Interface\\AddOns\\Forte_Core\\Textures\\Runes",
		"Interface\\AddOns\\Forte_Core\\Textures\\Xeon",
		"Interface\\AddOns\\Forte_Core\\Textures\\SWSDefault",
		"Interface\\AddOns\\Forte_Core\\Textures\\Flat",
		"Interface\\TargetingFrame\\UI-StatusBar",
		"Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar",
};

function FW:SoundName(sound)
	for i, data in ipairs(FW.SoundList) do
		if strlower(data[1]) == strlower(sound) then
			return data[2];
		end
	end
	return "Custom Sound";
end

function FW:FontName(font)
	for i, data in ipairs(FW.FontList) do
		if strlower(data[1]) == strlower(font) then
			return data[2];
		end
	end
	return "Custom Font";
end

function FW:TypeName(t,list)
	for i, data in ipairs(list) do
		if data[1] == t then
			return data[2];
		end
	end	
end

FW.Modules = {};
function FW:ClassModule(module)
	FW.ClassModules = module;
	return FW:Module(module);
end
function FW:Module(module)
	FW.Modules[module] = {};
	return FW.Modules[module];
end

----------------------------------------------------------------------------------------------------------------------------
--------- STUFF TO MINIMIZE TABLE MEMORY GARBAGE SINCE I LIKE TO USE '2D' TABLES A LOT -------------------------------------
----------------------------------------------------------------------------------------------------------------------------

local function FW_BSTR(t,i,j,c,asc,a)
	local val1 = t[j-1][ c[a] ];
	local val2 = t[j][ c[a] ];
	
	if val1 == val2 then
		if c[a+1] then		
			FW_BSTR(t,i,j,c,asc,a+1);
		end
	elseif asc[a] == (val1 > val2) then
		t[j-1],t[j] = t[j],t[j-1];
	end
end

local function FW_BST(t,c,asc) -- sorts my '2d table', using 'column - ascending' table pairs
	local i = 1;
	local j;
	while i <= t.rows do
		j = t.rows;
		while i<j do
			FW_BSTR(t,i,j,c,asc,1);
			j=j-1;
		end
		i=i+1;
	end
end

local function FW_INS(t,...) -- insert new row, must be the same number of columns (for sort to work properly)!!
	t.rows = t.rows + 1;
	if t[t.rows] then
		for i=1,select('#',...),1 do
			t[t.rows][i] = select(i,...);
		end
	else
		tinsert(t,{...});
	end
end

local function FW_REM(t,row) -- remove row
	if row and row <= t.rows then
		t.rows=t.rows-1;
		for r=row,t.rows,1 do
			t[r],t[r+1] = t[r+1],t[r];
		end
	end
end

local function FW_ERASE2(t) -- erases my 2d tables ONLY
	t.rows = 0; -- lol :p
end

local function FW_GET(t,r,c)  -- UNUSED gets an element from my '2d table' if c column is nil it will return every val in this row :D
	if c then
		return t[r][c];
	else
		return unpack(t[r]);
	end
end

local function FW_SET(t,r,c,v) -- UNUSED sets an element in my '2d table'
	t[r][c] = v;
end

local function FW_FIND(t,v,c) -- find value v in '2d table' t at column c, returns ROW
	for r=1,t.rows,1 do
		if t[r][c]==v then
			return r;
		end
	end
end

local function FW_FIND2(t,v1,c1,v2,c2) -- returns ROW
	for r=1,t.rows,1 do
		if t[r][c1]==v1 and t[r][c2]==v2 then
			return r;
		end
	end
end

local function FW_FIND3(t,v1,c1,v2,c2,v3,c3) -- returns ROW
	for r=1,t.rows,1 do
		if t[r][c1]==v1 and t[r][c2]==v2 and t[r][c3]==v3 then
			return r;
		end
	end
end

local function FW_SETKEY(t,k,...) -- Set a row with 'key', MUST have the same num columns!
	local n = FW_FIND(t,k,1);
	if n then
		for i=1,select('#',...),1 do
			t[n][i+1] = select(i,...);
		end
	else
		FW_INS(t,k,...);
	end
end

local function FW_P(t)
	local str;
	for r=1,t.rows,1 do
		str = "";
		for c=1,#t[r],1 do
			str = str.." "..t[r][c];
		end
		FW:Show(str);
	end
end

function FW:NEW2D() -- CURRENTLY ONLY SUPPORTS A STATIC NUMBER OF COLUMNS (for one 2d table) TO INCREASE PERFORMANCE!!
	local t = {};
	t.rows = 0;
	t.erase = FW_ERASE2;
	t.remove = FW_REM;
	t.insert = FW_INS;
	t.find = FW_FIND;
	t.find2 = FW_FIND2;
	t.find3 = FW_FIND3;
	t.sort = FW_BST;
	t.setkey = FW_SETKEY;
	t.print = FW_P;
	return t;
end

----------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------

local DeleteOld = 3600;

FW.GET_SHARDS = "SG";
FW.GET_HEALTHSTONE = "HG"
FW.SEND_HEALTHSTONE = "HS";
FW.SEND_SHARDS = "SH";

local SEND_VERSION = "VE"
local GET_VERSION = "VG";
local GET_SPECC = "SPG";
local SEND_SPECC = "SPS";

local LastRess;
local LeaveCombat;
local UILoaded;

local SynchBuffer = FW:NEW2D();
local SynchBufferUpdate = -1;

FW.LastShardCheck = 0;
FW.LastHSCheck = 0;

FW.Healthstone = {};

FW.Zones = {};
FW.Ranks = {};
FW.Version = {};
FW.Ready = {};

FW.SetBonus = {};
FW.Talent = {};
FW.Glyph = {};

FW.SpellInfo = {};-- id [,casttime,minrange,maxrange]

function FW:RegisterCustomName(id,name)
	CustomIDToName[id] = name;
	CustomNameToID[name] = id;
end

function FW:SpellName(spell)
	local s,_,t = GetSpellInfo(spell);
	s = CustomIDToName[spell] or s;
	if s then
		if not FW.SpellInfo[s] then
			FW.SpellInfo[s] = {spell,0,0,0};
		end
		return s,t;
	else
		return spell;
	end
end

function FW:CastTime(spell)
	return FW.SpellInfo[spell] and FW.SpellInfo[spell][2] or 0;
end

function FW:SpellId(name)
	return FW.SpellInfo[name][1] or name;
end

function FW:FrameScaleCheck(editbox)
	local num = tonumber(editbox:GetText());
	if num then
		if num < 0.2 then 
			return 0.2;
		elseif num > 5.0 then
			return 5.0;
		end
		return num;
	end
end
function FW:FrameAlphaCheck(editbox)
	local num = tonumber(editbox:GetText());
	if num then
		if num < 0.1 then 
			return 0.1;
		elseif num > 1.0 then
			return 1.0;
		end
		return num;
	end
end

function FW:NumberCheck(editbox)
	local num = tonumber(editbox:GetText());
	if num then
		if editbox.maximum and num>editbox.maximum then
			return editbox.maximum;
		elseif editbox.minimum and num<editbox.minimum then
			return editbox.minimum;
		end
		return num;
	end
end

local function FW_Largest(x,y)
	if x>y then
		return x;
	else
		return y;
	end
end

function FW:FixIntensity(r,g,b)
	local largest = FW_Largest(FW_Largest(r,g),b);
	if largest < 1 then
		return 0.7*r/largest+0.3,0.7*g/largest+0.3,0.7*b/largest+0.3;
	else
		return 0.7*r+0.3,0.7*g+0.3,0.7*b+0.3;
	end
end

local FC_DelayedExecQueue = FW:NEW2D();
local function FC_DelayedExec(update)
	local t = GetTime();
	local i = 1;
	while i <= FC_DelayedExecQueue.rows  do
		if FC_DelayedExecQueue[i][1] <= t then
			 FC_DelayedExecQueue[i][4](unpack(FC_DelayedExecQueue[i],5));
			 if FC_DelayedExecQueue[i][3] > 1 then
				  FC_DelayedExecQueue[i][3]=FC_DelayedExecQueue[i][3]-1;
				   FC_DelayedExecQueue[i][1] = FC_DelayedExecQueue[i][1] + FC_DelayedExecQueue[i][2];
			 else
				 for k in ipairs(FC_DelayedExecQueue[i]) do -- erase all data so i can use any argument count
					FC_DelayedExecQueue[i][k] = nil;
				 end
				 FC_DelayedExecQueue:remove(i);
			end
		else
			i=i+1;
		end
	end
end

function FW:DelayedExec(delay,times,func,...)
	FC_DelayedExecQueue:insert(GetTime()+delay,delay,times,func,...);
end

function FW:ItemName(item)
	return (GetItemInfo(item)) or "unknown";
end

function FW:Changed(unit)
	FW[unit] = UnitGUID(unit);
end

function FW:ShowTip(self)
	if self.tip and self.title and FW.Settings.Tips then
		GameTooltip_SetDefaultAnchor(GameTooltip, self);
		GameTooltip:SetText(self.title, 1.0, 1.0, 1.0);
		GameTooltip:AddLine(self.tip, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1);
		GameTooltip:Show();
	end
end

function FW:HideTip(self)
	HideUIPanel(GameTooltip);
end

local function FW_VersionCheck()
	FW:SendData(GET_VERSION);
end
local function FW_GetSpeccInfo()
	FW:SendData(GET_SPECC);
end

function FW:HealthstoneSpecc(player)
	if FC_Saved.Speccs.WARLOCK and FC_Saved.Speccs.WARLOCK[player] then
		return tonumber(strsub(FC_Saved.Speccs.WARLOCK[player], strlen(FC_Saved.Speccs.WARLOCK[player])-1 ));
	else
		return 0;
	end
end

local function FW_HealthstoneRankByLevel(unit)
	if select(2,UnitClass(unit)) == "WARLOCK" then
		local level = UnitLevel(unit);
		if level < 10 then
			return 0;
		elseif level < 22 then
			return 1;
		elseif level < 34 then
			return 2;
		elseif level < 46 then
			return 3;
		elseif level < 58 then
			return 4;
		elseif level < 68 then
			return 5;
		elseif level < 73 then
			return 6;
		elseif level < 78 then
			return 7;
		else
			return 8;
		end
	else
		return 0;
	end
end

local createhs = FW:SpellName(47878);
local function FW_HealthstoneRank()
	if FW.CLASS == "WARLOCK" then
		local high = 0;
		local spellName, spellRank;
		local i = 1
		
		while true do
			spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
			if spellName then
				if spellName == createhs then
					spellRank = tonumber(select(3,strfind(spellRank,"(%d+)")));
					if spellRank > high then
						high = spellRank;
					end
				end
				i = i + 1;
			else
				break;
			end
		end
		return high;
	else
		return 0;
	end
end

local function FW_HealthstoneAdd(specc) -- adds a healstone type to track at the hs spy
	table.sort(FW.Healthstone);
	for k, v in ipairs(FW.Healthstone) do
		if v == specc then
			return;
		end
	end
	if #FW.Healthstone >= FW.Settings.HealthstoneNumber then
		if specc > FW.Healthstone[1] then
			FW.Healthstone[1] = specc;
		end
	else
		tinsert(FW.Healthstone,specc);
	end
end

function FW:CreateHealthstoneTypes() -- decides what types of healthstone to track based on warlock speccs, also called from healthstone module
	erase(FW.Healthstone);
	local specc;
	
	for warlock, data in pairs(FC_Saved.Shards) do
		if data[2] == FC_Saved.Update then
			specc = FW:HealthstoneSpecc(warlock);
			while (specc > 0) do
				FW_HealthstoneAdd(specc);
				specc = specc - 3;
			end
		end
	end
	
	if FW.Settings.HealthstoneTopRank then
		local i = #FW.Healthstone;
		if i>0 then
			local top = FW.ID_HEALTHSTONE[ FW.Healthstone[i] ][4];
			while (i>0) do
				if FW.ID_HEALTHSTONE[FW.Healthstone[i]][4] < top then
					tremove(FW.Healthstone,i);
				end
				i=i-1;
			end
		end
	end
end

local function FW_MakeSpeccInfo(inspect) -- creates you own specc information string, or that of someone you're inspecting
	local player,class,hsrank;
        if inspect then
        	if not InspectFrame or not InspectFrame.unit then return; end -- avoid saving wrong speccs to the wrong ppl for now!!
        	player = UnitName("target");
        	class = select(2,UnitClass("target"));
		if not player or not class or (not UnitInParty("target") and not UnitInRaid("target")) or player == FW.PLAYER then return;end
		hsrank = FW_HealthstoneRankByLevel("target");
	else
		player = FW.PLAYER;
		class = FW.CLASS;
		hsrank = FW_HealthstoneRank();
	end
	--FW:Show("building talents for "..player);
	local currentRank;
	local str = "";
	for tab=1,GetNumTalentTabs(inspect),1 do
		for i=1,GetNumTalents(tab,inspect),1 do
			currentRank = ( select( 5,GetTalentInfo(tab,i,inspect,nil,GetActiveTalentGroup(inspect)) ) );
			if currentRank > 0 then
				str = str..strformat("%02d",i)..currentRank;
			end
		end
		str=str.." ";
	end
	if not FC_Saved.Speccs[class] then
		FC_Saved.Speccs[class] = {};
	end
	if hsrank == 0 then
		FC_Saved.Speccs[class][player] = str.."00";
	else
		FC_Saved.Speccs[class][player] = str..strformat( "%02d", 3*hsrank+select(5,GetTalentInfo(2,1,inspect,nil,GetActiveTalentGroup(inspect)))-2 );
	end
	FW:CreateHealthstoneTypes();
	-- will later use the last digits for other classes as well, for now it's always zero for non-warlocks
end

local function FW_EnterCombat()
	--FW:ShowDebug("enter combat");
	for i,f in ipairs(FW_OnEnterCombat) do
		f();
	end
end
local function FW_LeaveCombat()
	--FW:ShowDebug("leave combat");
	for i,f in ipairs(FW_OnLeaveCombat) do
		f();
	end
end

local function FW_Ress()
	if not UnitIsDeadOrGhost("player") and not LastRess then
		LastRess = GetTime()+5; -- wait 5 seconds with checking combat
	end
	--[[if FW.Modules.Timer then
		FW:PauzeScansFor(0.5);
	end]]
end

---------------------------------------------------------------------------

local function FC_OnEvent(self,event,...)
	--if event=="CHAT_MSG_ADDON"  then
	--[[if strfind(event,"SUMMON")  then
		--if strfind(arg2,"SUMMON") or strfind(arg2,"UNIT_DIED") then
			local d = GetTime().." "..event;
			for i=1,select('#',...),1 do
				if select(i,...) ~= nil then d = d.." #"..i..":"..tostring(select(i,...)); end
			end
			FW:Show(d,0,1,1);
		--	FW:Show(GetTime().." tick",0,1,1);
		--end
	end]]
	
	if FW_Events[event] then 
		for k,v in ipairs(FW_Events[event]) do
			v(event,...);
		end
	end
end

------------------------------------------------------------------------------------------------------------------
local FW_Scans = {};
--FW.Online = {};

local function FW_ScanUnit(unit,update)
	local unitName = UnitName(unit);
	local _, unitClass = UnitClass(unit);
	local flag;
	if UnitIsConnected(unit) then
		if UnitIsDeadOrGhost(unit) then	
			flag = FW.FLAG_DEAD;
		else
			flag = FW.FLAG_NORMAL;
		end
	else
		flag = FW.FLAG_OFFLINE;
	end
	
	for i,f in ipairs(FW_Scans) do
		f(unit,unitName,unitClass,flag,update);
	end
end

local function FW_Scan()
	
	local update = GetTime();
	--
	for k in pairs(FW.Ready) do
		FW.Ready[k][2] = -1;
	end
	FW:RosterInfo();
	
	-- ss scan, raid or party
	if GetNumRaidMembers() > 0 then	
		-- Do scans
		for i=1,GetNumRaidMembers(),1 do
			FW_ScanUnit(RAID[i],update);
		end
	else	
		for i=1,GetNumPartyMembers(),1 do
			FW_ScanUnit(PARTY[i],update);
		end
		FW_ScanUnit("player",update);
	end
	FC_Saved.Update = update; 
	-- updating raw data complete
end

local function FW_ShardScan(unit,unitName,unitClass,flag,update)
	
	if FW:IsWarlock(unit) then

		if not FC_Saved.Shards[unitName] then
			FC_Saved.Shards[unitName] = {-1,update,FW.FLAG_NORMAL};
		end
		FC_Saved.Shards[unitName][2] = update;
		FC_Saved.Shards[unitName][3] = flag;
	end
end

local function FW_HealthstoneScan(unit,unitName,unitClass,flag,update)
	if not FC_Saved.Healthstone[unitName] then
		FC_Saved.Healthstone[unitName] = {};
		FC_Saved.Healthstone[unitName][0] = update;
	end
	if flag ~= FW.FLAG_OFFLINE then FC_Saved.Healthstone[unitName][0] = update;end
end

local function FW_Bartender4_UpdateCount(self)
	local action = self.action;
	if not IsStackableAction(action) and ((GetActionInfo(action))=="spell" or not IsConsumableAction(action)) then
		self.count:SetText("");
	end
end

local function FW_ActionButton_UpdateCount(self)
	local text = _G[self:GetName().."Count"];
	local action = self.action;
	if not IsStackableAction(action) and ((GetActionInfo(action))=="spell" or not IsConsumableAction(action)) then
		text:SetText("");
	end
end

local function FW_RegisterBlockReagent()
	if FW.Settings.SafeBlockShardReagent then
		hooksecurefunc("ActionButton_UpdateCount", FW_ActionButton_UpdateCount);
	end
end

local SpecialSaved = {};
local function FW_Reset()
	for k, v in pairs(SpecialSaved) do
		if v==true then
			erase(FC_Saved[k]);
		end
	end
end
local function FW_ResetOld(t)
	for key, val in pairs(SpecialSaved) do
		if val==true then
			for k, v in pairs(FC_Saved[key]) do
				if type(v)=="table" then
					if (v[0]) then
						if(t-v[0] > 900) then
							FC_Saved[key][k] = nil;
						end
					elseif (v[2]) then
						if (t-v[2] > DeleteOld) then
							FC_Saved[key][k] = nil;
						end
					end
				elseif (t-FC_Saved.Update > DeleteOld) then
					FC_Saved[key][k] = nil;
				end
			end
		end
	end
end

local function FW_RefreshAllFilters()
	for i,f in ipairs(FilterRefresh) do
		f();
	end
end

local function FW_InitConfig2(from,to)
	for key, val in pairs(from) do
		if type(val) == "table" then
			if to[key] == nil or type(to[key]) ~= "table" then
				to[key] = {};
			end
			FW_InitConfig2(val,to[key]);
		else
			if to[key] == nil then
				to[key] = val;
			end
		end
	end
end

--[[local function FW_Copy(from,to)
	if type(from) == "table" then
		for key, val in pairs(from) do
			if to[key] == nil or type(to[key]) ~= "table" then
				to[key] = {};
			end
		end
		FW_Copy(val,to[key]);
	else
		to = from;
	end
end]]

local function FW_InitConfig3(from,to) -- copies old saved data to the new profile format
	for key, val in pairs(from) do
		if SpecialSaved[key] == nil then
			if type(val) == "table" then
				if to[key] == nil or type(to[key]) ~= "table" then
					to[key] = {};
				end
				FW_InitConfig2(val,to[key]);
			else
				if to[key] == nil then
					to[key] = val;
					
				end
			end
			from[key] = nil;
		end
	end
end

function FW:FullName()
	return FW.PLAYER.."-"..FW.SERVER;
end

local function FW_InitConfig()

	if FC_Saved.Profiles == nil then 
		FC_Saved.Profiles = {};
		
		FC_Saved.Profiles["Default"] = {};
		FW_InitConfig3(FC_Saved,FC_Saved.Profiles["Default"]);
		FC_Saved.PROFILE = "Default";
	end
	if FC_Saved.PROFILES == nil then
		FC_Saved.PROFILES = {};
	end
	if FC_Saved.PROFILES[FW:FullName()] then -- load the proper profile or use the last used one if loading for the first time
		
		FW:UseProfile(FC_Saved.PROFILES[FW:FullName()],1); -- <-- new style profiles

	elseif FC_Saved.Profiles[FW.PLAYER.." "..FW.SERVER] then -- attempt to load the right 'old style' profile
		FW:UseProfile(FW.PLAYER.." "..FW.SERVER,1);
	elseif FC_Saved.Profiles[strlower(FW.PLAYER).." "..strlower(FW.SERVER)] then
		FW:UseProfile(strlower(FW.PLAYER).." "..strlower(FW.SERVER),1);
	
	elseif FC_Saved.Profiles[FW.CLASS] then
		FW:UseProfile(FW.CLASS,1);
	elseif FC_Saved.Profiles[strlower(FW.CLASS)] then
		FW:UseProfile(strlower(FW.CLASS),1);
	else
	
		FW:UseProfile(FC_Saved.PROFILE,1); -- <-- simply use the last active profile if i can't find any match
		
	end
end

local function FW_FixSetting(p,old,new)
	if FC_Saved.Profiles[p][old] ~= nil then
		FC_Saved.Profiles[p][new] = FC_Saved.Profiles[p][old];
		FC_Saved.Profiles[p][old] = nil;
	end
end

local function FW_FixNum(p,old)
	if FC_Saved.Profiles[p][old] ~= nil and FC_Saved.Profiles[p][old.."Enable"] == nil then
		if FC_Saved.Profiles[p][old] == 0 then
			FC_Saved.Profiles[p][old.."Enable"] = false;
			FC_Saved.Profiles[p][old] = FW.Default[old] or FC_Saved.Profiles[p][old];
		else
			FC_Saved.Profiles[p][old.."Enable"] = true;
		end
	end
end

local function FW_InitFrameVars() -- also contains compatibility fixes (these should be removed at some point, e.g. ver2.00)
	for f,d in pairs(FW.Frames) do
		if FC_Saved.Profiles then
			for p, v in pairs(FC_Saved.Profiles) do
				if not FC_Saved.Profiles[p][f] then
					FC_Saved.Profiles[p][f] = {};
				end
				if FC_Saved.Profiles[p][f].lock == nil then -- init value
					FC_Saved.Profiles[p][f].lock = (FW.Default[f] and FW.Default[f].lock) or FC_Saved.Profiles[p].GlobalLock;
				end
				if FC_Saved.Profiles[p][f].alpha == nil then -- init value
					FC_Saved.Profiles[p][f].alpha = (FW.Default[f] and FW.Default[f].alpha) or FC_Saved.Profiles[p].GlobalAlpha;
				end
				if FC_Saved.Profiles[p][f].scale == nil then -- init value
					FC_Saved.Profiles[p][f].scale = (FW.Default[f] and FW.Default[f].scale) or FC_Saved.Profiles[p].GlobalScale;
				end
			end
		end
	end
end

local function FW_ConvertFilter(p,filter)
	-- first under the spell name I first have the 'type' indexes, with the old format data inside
	-- index 0 is reserved to remember the last selected 'type' (interface use only)
	if FC_Saved.Profiles[p][filter]	then
		for key, val in pairs(FC_Saved.Profiles[p][filter]) do
			if type(key) == "string" then
				if type(val[1]) ~= "table" and val[1] ~= nil then -- make sure I only do this once, just in case!!!!
					tinsert(FC_Saved.Profiles[p][filter][key],1,{});
					for i=1,4,1 do
						FC_Saved.Profiles[p][filter][key][1][i] = FC_Saved.Profiles[p][filter][key][i+1];
						FC_Saved.Profiles[p][filter][key][i+1] = nil;
					end
				else
					
				end
			else -- remove the item ids if there were any added
				FC_Saved.Profiles[p][filter][key] = nil;
			end
		end
	end
end

local function FW_MoveSetting(p,old,new,target) -- make sure target is already a table!!
	--FW:Show("moving: pr:"..p.." old:"..old.." new:"..new.." ta:"..target);
	if FC_Saved.Profiles[p][old] ~= nil then
		if type(FC_Saved.Profiles[p][old]) == table then
			if type(FC_Saved.Profiles[p][target][new]) ~= "table" then
				FC_Saved.Profiles[p][target][new] = {};
			end
			FW_InitConfig2(FC_Saved.Profiles[p][old],FC_Saved.Profiles[p][target][new]); -- FW_InitConfig2 is basically a value/table copier so just use that
		else
			FC_Saved.Profiles[p][target][new] = FC_Saved.Profiles[p][old];
		end
		FC_Saved.Profiles[p][old] = nil;
	end
end
	
local function FW_Variables()
	local t = GetTime();
	
	FW:RegisterSpecialSaved("Profiles",false,nil);
	FW:RegisterSpecialSaved("VERSION",false,"");
	FW:RegisterSpecialSaved("RAID",false,false);
	FW:RegisterSpecialSaved("PARTY",false,false);
	--FW:RegisterSpecialSaved("SCALE",false,1);
	FW:RegisterSpecialSaved("PROFILE",false,"");
	FW:RegisterSpecialSaved("Speccs",false,{});
	FW:RegisterSpecialSaved("Exceptions",false,{});
	FW:RegisterSpecialSaved("Update",false,0);
	
	FW:RegisterSpecialSaved("GotORA",true,{});
	
	FW:RegisterSpecialSaved("Timers",true,{});
	FW:RegisterSpecialSaved("Warlocks",true,{});
	FW:RegisterSpecialSaved("Cooldowns",true,{});
	FW:RegisterSpecialSaved("Shards",true,{});
	FW:RegisterSpecialSaved("Healthstone",true,{});

	
	FW_InitConfig2(FW.Exceptions,FC_Saved.Exceptions);
	
	--FC_Saved.VERSION = "v1.91"; -- REMOVE IF NOT TESTING!!!!!
	
	if FC_Saved.VERSION ~= VERSION then -- version change
	
	
		-- !!! COMPATIBILITY FIXES !!! --
		if FC_Saved.VERSION < "v1.07" then
			
			if FC_Saved.Profiles then
				for p, v in pairs(FC_Saved.Profiles) do
				
					--locks
					FW_FixSetting(p,"TimerDisableButtons","TimerLock");
					FW_FixSetting(p,"CooldownDisableButtons","CooldownLock");

				end
			end
		end
		if FC_Saved.VERSION < "v1.08" then
			
			if FC_Saved.Profiles then
				for p, v in pairs(FC_Saved.Profiles) do
					--locks
					FW_FixSetting(p,"CooldownSecondSplashLock","SplashLock");

				end
			end
		end
		if FC_Saved.VERSION < "v1.13" then
			if FC_Saved.Profiles then -- switch off dot listening for now
				for p, v in pairs(FC_Saved.Profiles) do
					if FC_Saved.Profiles[p]["TimerImprove"] ~= nil then
						FC_Saved.Profiles[p]["TimerImprove"] = false;
					end
				end
			end
		end
		if FC_Saved.VERSION < "v1.14" then
			-- from now on i store filters a bit diffrently
			if FC_Saved.Profiles then
				for p, v in pairs(FC_Saved.Profiles) do
					FW_ConvertFilter(p,"TimerFilter");
					FW_ConvertFilter(p,"CooldownFilter");
				end
			end
		end
		if FC_Saved.VERSION < "v1.90" then
			--FW:Show("CONVERTING SETTINGS");
			-- convert settings to new format
			if FC_Saved.Profiles then
				for p, v in pairs(FC_Saved.Profiles) do

					-- SPELL TIMER
					if type(FC_Saved.Profiles[p]["Timer"]) == "boolean" then
						FW_FixSetting(p,"Timer","TimerEnable");
					end								
					if type(FC_Saved.Profiles[p]["Timer"]) ~= "table" then
						FC_Saved.Profiles[p]["Timer"] = {};
					end				
					--copy frame variables
					if FC_Saved.Profiles[p]["FWSTFrame"] then
						FW_InitConfig2(FC_Saved.Profiles[p]["FWSTFrame"],FC_Saved.Profiles[p]["Timer"]);
						if FC_Saved.Profiles[p]["Timer"].y then -- fix pos due to new frame
							if FC_Saved.Profiles[p]["TimerExpand"] then
								FC_Saved.Profiles[p]["Timer"].y = FC_Saved.Profiles[p]["Timer"].y + 20;
							else
								FC_Saved.Profiles[p]["Timer"].y = FC_Saved.Profiles[p]["Timer"].y - 20;
							end
						end
						FC_Saved.Profiles[p]["FWSTFrame"] = nil;
					end
					
					-- all settings without Timer in front
					FW_MoveSetting(p,"DrainColor","DrainColor","Timer");
					FW_MoveSetting(p,"DrainEnable","DrainEnable","Timer");
					FW_MoveSetting(p,"CurseColor","CurseColor","Timer");
					FW_MoveSetting(p,"CurseEnable","CurseEnable","Timer");
					FW_MoveSetting(p,"CrowdColor","CrowdColor","Timer");
					FW_MoveSetting(p,"CrowdEnable","CrowdEnable","Timer");
					FW_MoveSetting(p,"MagicColor","MagicColor","Timer");
					FW_MoveSetting(p,"MagicEnable","MagicEnable","Timer");
					FW_MoveSetting(p,"PetColor","PetColor","Timer");
					FW_MoveSetting(p,"PetEnable","PetEnable","Timer");
					FW_MoveSetting(p,"BuffColor","BuffColor","Timer");
					FW_MoveSetting(p,"BuffEnable","BuffEnable","Timer");
					FW_MoveSetting(p,"HealColor","HealColor","Timer");
					FW_MoveSetting(p,"HealEnable","HealEnable","Timer");
					FW_MoveSetting(p,"FriendlyBuffColor","FriendlyBuffColor","Timer");
					FW_MoveSetting(p,"FriendlyBuffEnable","FriendlyBuffEnable","Timer");
					FW_MoveSetting(p,"DebuffsColor","DebuffsColor","Timer");
					FW_MoveSetting(p,"DebuffsEnable","DebuffsEnable","Timer");
					FW_MoveSetting(p,"HighlightColor","HighlightColor","Timer");
					FW_MoveSetting(p,"HighlightEnable","HighlightEnable","Timer");
					FW_MoveSetting(p,"FailColor","FailColor","Timer");
					FW_MoveSetting(p,"FailEnable","FailEnable","Timer");
					
					for key, val in pairs(FC_Saved.Profiles[p]) do
						local s,e = strfind(key,"^Timer");
						if s and key ~= "Timer"
						and not strfind(key,"TimerResists")
						and not strfind(key,"TimerFadeSound")
						and not strfind(key,"TimerBreak")
						and not strfind(key,"TimerResist")
						and not strfind(key,"TimerInstant")
						and not strfind(key,"TimerImprove")
						then
							FW_MoveSetting(p,key,strsub(key,e+1),"Timer");
						end
					end
		
					-- COOLDOWN SPLASH
					if not FC_Saved.Profiles[p]["Splash"] then
						FC_Saved.Profiles[p]["Splash"] = {};
					end				
					if FC_Saved.Profiles[p]["FWCDSplash"] then
						FW_InitConfig2(FC_Saved.Profiles[p]["FWCDSplash"],FC_Saved.Profiles[p]["Splash"]);
						FC_Saved.Profiles[p]["FWCDSplash"] = nil;
					end
					FW_MoveSetting(p,"CooldownSecondSplash","Enable","Splash"); 
					FW_MoveSetting(p,"CooldownSecondSplashMax","SecondSplashMax","Splash");
					FW_MoveSetting(p,"CooldownSplashGlow","SplashGlow","Splash"); 
					
					-- COOLDOWN TIMER						
					if type(FC_Saved.Profiles[p]["Cooldown"]) == "boolean" then
						FW_FixSetting(p,"Cooldown","CooldownEnable");
					end
					if type(FC_Saved.Profiles[p]["Cooldown"]) ~= "table" then
						FC_Saved.Profiles[p]["Cooldown"] = {};
					end				
					if FC_Saved.Profiles[p]["FWCDFrame"] then
						FW_InitConfig2(FC_Saved.Profiles[p]["FWCDFrame"],FC_Saved.Profiles[p]["Cooldown"]);
						FC_Saved.Profiles[p]["FWCDFrame"] = nil;
					end
					for key, val in pairs(FC_Saved.Profiles[p]) do
						local s,e = strfind(key,"^Cooldown");
						if s and key ~= "Cooldown"
						and key ~= "CooldownLeft"
						and key ~= "CooldownLeftMsg" then
							FW_MoveSetting(p,key,strsub(key,e+1),"Cooldown");
						end
					end
					
					-- OTHER
					FW_FixSetting(p,"Shard","ShardEnable");
					FW_FixSetting(p,"Healthstone","HealthstoneEnable");
					FW_FixSetting(p,"Soulstone","SoulstoneEnable");
					FW_FixSetting(p,"Summon","SummonEnable");
					FW_FixSetting(p,"ShardManager","ShardManagerEnable");
					
					--change target/focus only settings into the new ones
					if FC_Saved.Profiles[p]["Timer"] and FC_Saved.Profiles[p]["Timer"]["Target"] ~= nil then
						if FC_Saved.Profiles[p]["Timer"]["Target"] then
							FC_Saved.Profiles[p]["Timer"]["Other"] = false;
						else
							FC_Saved.Profiles[p]["Timer"]["Target"] = true;
						end
					end
				end
			end
		end
		if FC_Saved.VERSION < "v1.92" then
			if FC_Saved.Profiles then
				for p, v in pairs(FC_Saved.Profiles) do
					-- at some point I had this option added already, but with other default value
					FC_Saved.Profiles[p]["IgnoreCooldown"] = FW.Default["IgnoreCooldown"];
					-- set this to the new default, since normal format kinda sucks now!
					FC_Saved.Profiles[p]["TimeFormat"] = FW.Default["TimeFormat"];
					FC_Saved.Profiles[p]["TimeLeftMsg"] = FW.Default["TimeLeftMsg"];
					FC_Saved.Profiles[p]["TimeLeftNoTargMsg"] = FW.Default["TimeLeftNoTargMsg"];
					FC_Saved.Profiles[p]["CooldownLeftMsg"] = FW.Default["CooldownLeftMsg"];
				end
			end
		end
		if FC_Saved.VERSION < "v1.955" then
		
			if FC_Saved.Profiles and GetLocale() == "ruRU" then
				for p, v in pairs(FC_Saved.Profiles) do
					FC_Saved.Profiles[p]["Font"] = "Fonts\\ARIALN.TTF";
					FC_Saved.Profiles[p]["FontSize"] = 11;
					FC_Saved.Profiles[p]["OptionsFont"] = "Fonts\\ARIALN.TTF";
					FC_Saved.Profiles[p]["OptionsFontSize"] = 11;
					FC_Saved.Profiles[p]["OptionsHeaderFont"] = "Fonts\\ARIALN.TTF";
					FC_Saved.Profiles[p]["OptionsHeaderFontSize"] = 11;
				end
			end
		end
		
		-- !!! END COMPATIBILITY FIXES !!! --
		FC_Saved.VERSION = VERSION;
	end
	FWOptions.Update = function(self)
		self:SetScale(FW.Settings.FWOptions.scale);
		self:SetAlpha(FW.Settings.FWOptions.alpha);
		FW:CorrectPosition(self);
	end;
	FW:RegisterFrame("FWOptions",FWOptions); -- needs to be done at least before FW_InitConfig!!!
	
	FW_InitConfig();
	
	FW:Show(FW:Title().." - /fx for options",0,1,0);
	FW:Show("Class Module: "..FW.ClassModules.." - Modules: "..FW:Size(FW.Modules),0,1,0);
	
	FW:ShowDebug("Warning: Debug mode is on!");
	
	if FC_Saved.Update > t then -- pc rebooted, have to clear all timers
		FW_Reset();
	else
		FW_ResetOld(t);
	end

	

	FW.Version[FW.PLAYER] = VERSION;
	
	for i,f in ipairs(FW_VariablesLoaded) do
		f();
	end
end

function FW:Title()
	return FW.TITLE.." "..VERSION.." by Xus - "..FC_Saved.PROFILE;
end

function FW:RegisterEnterPartyRaid(func)
	tinsert(FW_EnterPartyRaid,func);
end

local function FW_PartyRaid() -- also run on ui load plx!
	for i,f in ipairs(FW_EnterPartyRaid) do
		f(FC_Saved.RAID or FC_Saved.PARTY);
	end
end

local function FW_TimedRaidParty()
	local t1, t2 = IsInInstance();
	local t3, t4;
	if t1 and t2 ~= "raid" and t2 ~= "party" then -- switch everything raid related off if we're inside a battleground
		t3 = false;t4 = false;
	else
		t3 = GetNumRaidMembers()>0;
		t4 = GetNumPartyMembers()>0;
	end
	if FC_Saved.RAID ~= t3 then
		FC_Saved.RAID = t3;
		FW_PartyRaid();
	end
	if FC_Saved.PARTY ~= t4 then
		FC_Saved.PARTY = t4;
		FW_PartyRaid();
	end
end

local function FW_TimedClearBuffers()
  	if SynchBufferUpdate >= 5 then
		SynchBufferUpdate = -1;
		SynchBuffer:erase();--
	elseif SynchBufferUpdate ~= -1 then -- -1 means do nothing
		SynchBufferUpdate = SynchBufferUpdate + 1;
	end
end

local function FW_UpdateCore(elapsed)
	if LastRess and LastRess <= GetTime() then -- delays combat checking when you're ressed, so in case of a combat res or ss use your timers wont be cleared instantly
		if not InCombatLockdown() then FW_LeaveCombat(); end
		LastRess = nil;
	end
	if LeaveCombat then -- this is only used when zoning, to make sure buttons arent still locked when FW_LeaveCombat is called
		if not InCombatLockdown() then FW_LeaveCombat(); end
		LeaveCombat = nil;
	end
	-- run the timed events
	for key, val in pairs(FW_Timed) do
		FW_Timed[key][0] = FW_Timed[key][0] + elapsed;
		if FW_Timed[key][0] >= key then
			FW_Timed[key][0] = FW_Timed[key][0]%key;
			for k, v in ipairs(FW_Timed[key]) do
				v();
			end
		end
	end
			
end

local function FC_OnUpdate(self, elapsed)
	
	if ENABLE then
		for i, f in ipairs(FW_Updated) do
			f(elapsed);
		end
		FC_DelayedExec();
	else
		if UILoaded then -- enable update actions 2 sec after UI is fully loaded
			--FW:Show(GetTime() - UILoaded);
			
			if GetTime() - UILoaded >= FW.Settings.LoadDelay then
			
				ENABLE = true;-- do stuff when the addon is fully enabled!
				for i, f in ipairs(FW_DelayedLoaded) do
					f();
				end

			end
		else
			UILoaded = GetTime();
		end	
	end
end

-- ids here in in string form, not numbers!
function FW:RegisterSet(name,...)
	for i=1,select('#',...), 1 do
		FW.Sets[select(i,...)] = name;
	end
end

local function FW_RelevantTalent()
	--FW:Show("TALENTS");
	for tab=1,GetNumTalentTabs(),1 do
		for i=1,GetNumTalents(tab),1 do
			local name, _, _, _, rank = GetTalentInfo(tab, i, nil,nil,GetActiveTalentGroup());
			if FW.Talent[name] then
				FW.Talent[name] = rank;
			end
		end
	end
end

local function FW_RelevantStance()
	FW.Stance = GetShapeshiftForm();
	--FW:Show("STANCE "..FW.Stance);
end

local function FW_RelevantGlyph()
	for k, v in pairs(FW.Glyph) do
		FW.Glyph[k] = 0;
	end
	local enabled, glyphSpell;
	local i=1;
	while true do
		enabled, _, glyphSpell = GetGlyphSocketInfo(i,GetActiveTalentGroup());
		if glyphSpell then
			if enabled then
				--FW:Show(GetSpellInfo(glyphSpell));
				FW.Glyph[GetSpellInfo(glyphSpell)] = 1;
			end
			i=i+1;
		else
			return;
		end
	end
end

local function FW_RelevantSetBonus()
	--FW:Show( "SET SCAN" );
	for k, v in pairs(FW.SetBonus) do
		FW.SetBonus[k] = 0;
	end
	local t1;
	for i=1,12,1 do -- from head to 2nd ring
		t1 = GetInventoryItemLink("player", i);
		if t1 then
			t1 = select(3,strfind(t1,"^|c.-|Hitem:(.-):"));
			--FW:Show(t1);
			t1 = FW.Sets[t1];
			if t1 then
				FW.SetBonus[t1] = FW.SetBonus[t1] + 1;
			end
		end
	end
end

--[[function FW:UnitHasBuff(unit,buff) -- returns expirationTime
	--name 1, rank 2, icon 3, count 4, debuffType 5, duration 6, expirationTime 7, isMine 8, isStealable
	local d,t;
	d,_,_,_,_,_,t = UnitBuff(unit,buff);
	if d then return t; end
end]]

-- USE UnitBuff or UnitDebuff IF I DONT NEED THE INDEX (OR NEED MORE DATA OFC)
function FW:UnitHasBuff(unit,buff) -- returns expirationTime, index
	-- name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId
	local b = 1;
	local d,t,s,tt;--buff name, texture
	while true do
		d,_,_,s,_,tt,t = UnitBuff(unit,b);
		if d then
			if d == buff then
				return t,b,s,tt;
			end
			b=b+1;
		else
			return nil,b,0,0;
		end
	end
end

--[[function FW:UnitHasBuffID(unit,buffid) -- returns expirationTime, index
	-- name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId 
	local b = 1;
	local d,t,s,tt,id;--buff name, texture
	while true do
		d,_,_,s,_,tt,t,_,_,_,id = UnitBuff(unit,b);
		if d then
			if id == buffid then
				return t,b,s,tt,d;
			end
			b=b+1;
		else
			return nil,b,0,0,nil;
		end
	end
end]]

function FW:UnitHasYourBuff(unit,buff) -- returns expirationTime, index
	--name 1, rank 2, icon 3, count 4, debuffType 5, duration 6, expirationTime 7, isMine 8, isStealable 
	local b = 1;
	local d,t,m,s,tt;--buff name, texture
	while true do
		d,_,_,s,_,tt,t,m = UnitBuff(unit,b);
		if d then
	
			if d == buff and isMine[m] then
				return t,b,s,tt;
			end
			b=b+1;
		else
			return nil,b,0,0;
		end
	end
end

--[[function FW:UnitHasDebuff(unit,debuff) -- returns timeleft	--name 1, rank 2, icon 3, count 4, debuffType 5, duration 6, expirationTime 7, isMine 8, isStealable 
	local d,t;
	d,_,_,_,_,_,t = UnitDebuff(unit,debuff);
	if d then return t; end
end]]
-- USE UnitBuff or UnitDebuff IF I DONT NEED THE INDEX (OR NEED MORE DATA OFC)
function FW:UnitHasDebuff(unit,debuff) -- returns expirationTime, index
	--name 1, rank 2, icon 3, count 4, debuffType 5, duration 6, expirationTime 7, isMine 8, isStealable 
	local b = 1;
	local d,t,s,tt;--debuff name, expire time, mine
	while true do -- castable by you
		d,_,_,s,_,tt,t = UnitDebuff(unit,b);
		if d then
			if d == debuff then
				return t,b,s,tt;
			end
			b=b+1;
		else
			return nil,b,0,0;
		end
	end
end

function FW:UnitHasYourDebuff(unit,debuff) -- returns expirationTime, index
	--name 1, rank 2, icon 3, count 4, debuffType 5, duration 6, expirationTime 7, isMine 8, isStealable 
	local b = 1;
	local d,t,m,s,tt,r;--debuff name, expire time, mine
	while true do -- castable by you
		d,r,_,s,_,tt,t,m = UnitDebuff(unit,b);
		if d then
			if d == debuff and isMine[m] then
				--FW:Show("found");
				return t,b,s,tt,r;
			end
			b=b+1;
		else
			return nil,b,0,0,0;
		end
	end
end

function FW:SecToTimeD(t)
	if FW.Settings.TimeFormat then
		if t >= 60 then 
			return math.floor(t/60)..":"..strformat("%02d",t%60);
		else
			return strformat("%.1f",t);
		end
	else
		if t >= 60 then return ceil(t/60).."m";else return floor(t).."s"; end
	end
end

function FW:SecToTime(t)
	if FW.Settings.TimeFormat then
		return math.floor(t/60)..":"..strformat("%02d",t%60);
	else
		if t >= 60 then return ceil(t/60).."m"; else return floor(t).."s";end
	end
end

function FW:NameToRaidID(name)
	for i=1,GetNumRaidMembers(),1 do
		if name == UnitName(RAID[i]) then
			return RAID[i];
		end
	end
end
function FW:NameToPartyID(name)
	for i=1,GetNumPartyMembers(),1 do
		if name == UnitName(PARTY[i]) then
			return PARTY[i];
		end
	end
end
function FW:NameToID(name)
	if name == FW.PLAYER then return "player";end
	for i=1,GetNumPartyMembers(),1 do
		if name == UnitName(PARTY[i]) then
			return PARTY[i];
		end
	end
	for i=1,GetNumRaidMembers(),1 do
		if name == UnitName(RAID[i]) then
			return RAID[i];
		end
	end
end

function FW:RosterInfo()
	if not FC_Saved.RAID then return; end
	local t1,t2,t3;
	for i=1,40,1 do
		t1, t2, _, _, _, _, t3 = GetRaidRosterInfo(i);
		if t1 then
			FW.Ranks[t1] = t2;
			FW.Zones[t1] = t3;
		end
	end
end

function FW:IsWarlock(unit)
	if select(2,UnitClass(unit)) == "WARLOCK" then return 1;end
end

function FW:GotSoulstone() -- returns the name of the best ss in your inventory
	for i=#FW.ID_SOULSTONE ,1,-1 do
		if GetItemCount(FW.ID_SOULSTONE[i]) ~= 0 then
			return FW:ItemName(FW.ID_SOULSTONE[i]);
		end
	end
end

function FW:GotShards() -- returns number of shards
	return GetItemCount(FW.ID_SOULSHARD);
end

local createss = FW:SpellName(47884);
function FW:BestSoulstone() -- returns name of best soulstone you can create, ising in cooldown and soulstone module
	if FW.CLASS == "WARLOCK" then
		local i = 1
		local high = 1;
		local spellName, spellRank;
		while true do
			spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
			if spellName then
				if spellName == createss then
					spellRank = tonumber(select(3,strfind(spellRank,"(%d+)")));
					if spellRank > high then
						high = spellRank;
					end
				end
				i = i + 1;
			else
				break;
			end
		end
		return FW:ItemName(FW.ID_SOULSTONE[high]);
	else
		return FWL.NONE;
	end
end

function FW:GotThisHealthstone(healthstone) -- returns the best hs of this name
	for i=#FW.ID_HEALTHSTONE,1,-1 do
		if FW:ItemName(FW.ID_HEALTHSTONE[i][1]) == healthstone then
			if GetItemCount(FW.ID_HEALTHSTONE[i][1]) ~= 0 then
				return FW.ID_HEALTHSTONE[i][1],FW.ID_HEALTHSTONE[i][2];
			end
		end
	end
end

function FW:GotHealthstone() -- returns the name of the best hs in your inventory
	for i=#FW.ID_HEALTHSTONE,1,-1 do
		if GetItemCount(FW.ID_HEALTHSTONE[i][1]) ~= 0 then
			return FW:ItemName(FW.ID_HEALTHSTONE[i][1]),FW.ID_HEALTHSTONE[i][2];
		end
	end
end

function FW:BestHealthstone()
	if FW.CLASS == "WARLOCK" then
		local index = FW:HealthstoneSpecc(FW.PLAYER);
		local high = math.ceil(index/3);
		return FW:ItemName(FW.ID_HEALTHSTONE[index][1]),index,high;
	else
		return FWL.NONE,0,0;
	end
end

--[[
function FW:TimeStart()
	FW.StartTime = GetTime();
end

function FW:TimeEnd(label)
	FW:Show(label..": "..(GetTime()-FW.StartTime),0,0,1);
end]]

local function FW_SendVersion()
	FW:SendData(SEND_VERSION..VERSION);
end


local function FW_SendSpeccInfo()
	if FC_Saved.Speccs[FW.CLASS] and FC_Saved.Speccs[FW.CLASS][FW.PLAYER] then
		FW:SendData(SEND_SPECC..FC_Saved.Speccs[FW.CLASS][FW.PLAYER]);
	--else
		--FW:Show("failed to send");
	end
end

local function FW_SynchBufferOut(msg,from)
	--FW:ShowDebug("New Synched "..from..": "..msg);
	for i,d in ipairs(FW_Messages) do
		if strfind(msg,d[1]) then
			--FW:ShowDebug("Running function for "..d[1]);
			d[2]( strsub(msg,strlen(d[1])), from );
			return;
		end
	end
end

local function FW_SynchBufferIn(msg,from,self)
	if not self and from == FW.PLAYER then return; end -- ignore message from yourself by default
	for i,d in ipairs(FW_Messages) do
		if strfind(msg,d[1]) then
			if d[3] then -- messages that need to be merged, rest are always 'unique' --
				SynchBufferUpdate = 0;
				local index = SynchBuffer:find(msg,2);-- might not be worth the cpu cost tbh
				if index then
					local f,m,n;

					index = SynchBuffer:find2(from,1,msg,2);
					if index then
						SynchBuffer[index][3] = SynchBuffer[index][3] + 1;
						for i=1,SynchBuffer.rows,1 do
							f,m,n = unpack(SynchBuffer[i]);
							if f ~= from and SynchBuffer[index][3] <= n and m == msg then
								return;
							end
						end
					else
						SynchBuffer:insert(from,msg,1);
						for i=1,SynchBuffer.rows,1 do
							f,m,n = unpack(SynchBuffer[i]);
							if f ~= from and n>=1 and m == msg then
								return;
							end
						end
					end
				else
					SynchBuffer:insert(from,msg,1);
				end	
			end
			FW_SynchBufferOut(msg,from);
			return;
		end
	end
	--FW:ShowDebug("Unknown Synched "..from..": "..msg);
end

local function FW_AddonMessage(event,...)
	local arg1,arg2,arg3,arg4 = ...;
	if arg1 == PREFIX then
		FW_SynchBufferIn(arg2,arg4);
		--FW:Show(arg4..": "..arg2,0,1,1);
	elseif arg1 == "oRA" or arg1 == "CTRA" then
		--[[local debug = GetTime().." "..event;
		if arg1 then debug = debug.." "..tostring(arg1); end
		if arg2 then debug = debug.." "..tostring(arg2); end
		if arg3 then debug = debug.." "..tostring(arg3); end
		if arg4 then debug = debug.." "..tostring(arg4); end
		FW:Show(debug,0,1,1);]]
		local found,t1,t2;
		for i,d in ipairs(FW_oRAMessages) do
			if not d[3] or not FW.Version[f] then --check only receive from ora if this player doesnt have fw
				found,_,t1,t2 = strfind(arg2,d[1]);
				if found then
					--FW:ShowDebug("Running function for "..d[1]);
					if d[2]( t1,t2, arg4 ) then return;end; -- stop looking if function actually returns something

				end
			end
		end
	end
end

function FW:Grouped()
 return FC_Saved.RAID or FC_Saved.PARTY;
end

--------------------------------------------
function FW:SendMergedData(msg)
	FW_SynchBufferIn(msg,FW.PLAYER,true); -- dont wait for data channel with messages sent by self
	if FW:Grouped() then
		SendAddonMessage(PREFIX,msg,"RAID");
	end
end

function FW:SendData(msg)
	FW_SynchBufferOut(msg,FW.PLAYER);
	if FW:Grouped() then
		SendAddonMessage(PREFIX,msg,"RAID");
	end
end
--------------------------------------------

--[[function FW:ORAItemCheckDisabled()
	if oRA and oRA.consoleOptions.args["item"] and oRA.consoleOptions.args["item"].args["disableItem"] and oRA.consoleOptions.args["item"].args["disableItem"].get then 
		return oRA.consoleOptions.args["item"].args["disableItem"].get();
	else
		return true;
	end
end]]

function FW:CheckHealthstone()
	local master = FW:Master();
	if master then
		for who in pairs(FC_Saved.Healthstone) do
			if FC_Saved.Healthstone[who][0]==FC_Saved.Update and not FW.Version[who] and FC_Saved.GotORA[who]==1 then
				
				for k, v in ipairs(FW.Healthstone) do
					FC_Saved.Healthstone[who][v] = 0;
				end
			end
		end
		if master == FW.PLAYER then
			-- fix to an oRA error
			if oRA and oRA.consoleOptions.args["item"] and oRA.consoleOptions.args["item"].handler then 
				for k, v in ipairs(FW.Healthstone) do
					oRA.consoleOptions.args["item"].handler:PerformItemCheck(tostring(FW.ID_HEALTHSTONE[v][1]));
				end
				oRA:CloseWindow();
			elseif  oRA and oRA.consoleOptions.args["item"] and oRA.consoleOptions.args["item"].args["check"] and oRA.consoleOptions.args["item"].args["check"].handler then 
				for k, v in ipairs(FW.Healthstone) do
					oRA.consoleOptions.args["item"].args["check"].handler:PerformItemCheck(tostring(FW.ID_HEALTHSTONE[v][1]));
				end
				oRA:CloseWindow();
			else
				for k, v in ipairs(FW.Healthstone) do
					SendAddonMessage("CTRA",FW.ORA_ITEM_REQUEST_SHORT..FW.ID_HEALTHSTONE[v][1],"RAID");
				end				
			end
		end
	end
end

function FW:CheckShards()
	local master = FW:Master();
	for who in pairs(FC_Saved.Shards) do
		if master and FC_Saved.Shards[who][3]~=FW.FLAG_OFFLINE and not FW.Version[who] and FC_Saved.GotORA[who]==1 then
			FC_Saved.Shards[who][1] = 0;
		end
	end
	if FW.CLASS == "WARLOCK" then FW:SendShards(FW:GotShards()); end
	
	if master == FW.PLAYER then
		-- fix to an oRA error
		if oRA and oRA.consoleOptions.args["item"] and oRA.consoleOptions.args["item"].handler then 
			oRA.consoleOptions.args["item"].handler:PerformItemCheck(tostring(FW.ID_SOULSHARD));
			oRA:CloseWindow();
		elseif oRA and oRA.consoleOptions.args["item"] and oRA.consoleOptions.args["item"].args["check"] and oRA.consoleOptions.args["item"].args["check"].handler then 
			oRA.consoleOptions.args["item"].args["check"].handler:PerformItemCheck(tostring(FW.ID_SOULSHARD));
			oRA:CloseWindow();
		else
			SendAddonMessage("CTRA",FW.ORA_SHARD_REQUEST,"RAID");
		end
		
	end
end

-- still want to reply to shards/healstonew requests no matter what modules are loaded
function FW:SendShards(n)
	SendAddonMessage(PREFIX,FW.SEND_SHARDS..n,"RAID");--can completely ignore this yourself
end

function FW:SendHealthstone(index,n)
	SendAddonMessage(PREFIX,FW.SEND_HEALTHSTONE..index.." "..n,"RAID");--can completely ignore this yourself
end

---------------------------------------------------------------------------
-- register functions
---------------------------------------------------------------------------
local FW_Chill = FW:NEW2D();

function FW:RegisterChill(func,arg1) -- every same function will only be triggered 20x per second by default
	for i=1,FW_Chill.rows,1 do
		 if FW_Chill[i][1] == func and FW_Chill[i][2] == arg1 then
			return;
		 end
	end
	FW_Chill:insert(func,arg1);
end

function FW_ExecuteChill()
	for i=1,FW_Chill.rows,1 do
		--FW:Show(tostring(FW_Chill[i][1]).."("..tostring(FW_Chill[i][2])..")");
		FW_Chill[i][1](FW_Chill[i][2]);
	end
	FW_Chill:erase();
end

function FW:RegisterORAMessage(start,func,ignorewithfw) -- note that the ora message recognition needs the function to give a return value to stop/break early
	tinsert(FW_oRAMessages,{"^"..start,func,ignorewithfw});
end

function FW:RegisterMessage(start,func,merge) -- will always stop/break when a prefix match is found at this time
	tinsert(FW_Messages,{"^"..start,func,merge});
end

function FW:RegisterSpecialSaved(saved,reset,default)
	SpecialSaved[saved] = reset;
	if FC_Saved[saved]==nil then  FC_Saved[saved] = default; end
end

function FW:RegisterOnProfileChange(func)
	tinsert(FilterRefresh,func);
end

-- the normal events aren't accurate enough in case of zoning for instance
function FW:RegisterOnLeaveCombat(func)
	tinsert(FW_OnLeaveCombat,func);
end
function FW:RegisterOnEnterCombat(func)
	tinsert(FW_OnEnterCombat,func);
end

function FW:RegisterScan(func)
	tinsert(FW_Scans,func);
end

function FW:AddCommand(k,f)
	Commands[k] = f;
end

function FW:GetFrame(name)
	return FW.Frames[name];
end

function FW:RegisterFrame(name,frame,combat_sensitive)
	FW.Frames[name] = frame;
	FW.Frames[name].combat_sensitive = combat_sensitive;
	FW.Frames[name].name = name;
end

function FW:RegisterToEvent(event,func)
	if not FW_Events[event] then
		FC_UpdateFrame:RegisterEvent(event);
		FW_Events[event] = {};
	end
	for i,f in ipairs(FW_Events[event]) do
		if f == func then
			return;
		end
	end
	tinsert(FW_Events[event],func);
end

function FW:UnregisterToEvent(event,func)
	if not FW_Events[event] then return; end
	for i,f in ipairs(FW_Events[event]) do
		if f == func then
			tremove(FW_Events[event],i);
			if #FW_Events[event]==0 then
				FW_Events[event] = nil;
				FC_UpdateFrame:UnregisterEvent(event);
			end
			return;
		end
	end
end

function FW:RegisterVariablesEvent(func)
	tinsert(FW_VariablesLoaded,func);
end

function FW:RegisterUpdatedEvent(func)
	tinsert(FW_Updated,func);
end

function FW:UnregisterUpdatedEvent(func)
	for i,f in ipairs(FW_Updated) do
		if f == func then
			tremove(FW_Updated,i);
			return;
		end
	end
end

function FW:RegisterLoadEvent(func)
	tinsert(FW_Loaded,func);
end

function FW:RegisterDelayedLoadEvent(func)
	tinsert(FW_DelayedLoaded,func);
end

function FW:RegisterTimedEvent(interval,func)
	if type(interval) == "string" then
		if FW.Settings[interval] then
			interval = FW.Settings[interval];
		else
			FW:Show("error adding interval: "..interval);
		end
	end
	if not FW_Timed[interval] then
		FW_Timed[interval] = {[0]=0};
	end
	tinsert(FW_Timed[interval],func);
end

function FW:UnregisterTimedEvent(interval,func)
	if type(interval) == "string" then
		if FW.Settings[interval] then
			interval = FW.Settings[interval];
		else
			FW:Show("error removing interval: "..interval);
		end
	end
	if FW_Timed[interval] then
		for i,f in ipairs(FW_Timed[interval]) do
			if f == func then
				tremove(FW_Timed[interval],i);
				return;
			end
		end
	end
end

---------------------------------------------------------------------------
-- some local frame functions
---------------------------------------------------------------------------
function FW:GetCenter(frame)
	local x,y = frame:GetCenter()
	return x*frame:GetEffectiveScale(),y*frame:GetEffectiveScale();
end

function FW:RefreshFrames()
	for f,d in pairs(FW.Frames) do
		d:Update();
	end
end

function FW:SetPosition(frame,x,y)
	frame:ClearAllPoints();
	frame:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x/frame:GetEffectiveScale(), y/frame:GetEffectiveScale());
end

local function FW_InitFramePositions(onload)
	for f,d in pairs(FW.Frames) do	
		if FW.Settings[f].x == nil or FW.Settings[f].y == nil then
			FW.Settings[f].x,FW.Settings[f].y = FW:GetCenter(UIParent);
		else
			FW:SetPosition( d ,FW.Settings[f].x,FW.Settings[f].y);
		end
	end
end
---------------------------------------------------------------------------
-- globally accessable
---------------------------------------------------------------------------
function FW:Master() -- returns the promoted warlock with the highest version (and 'highest' name after that)
	local master;
	for name in pairs(FW.Version) do
		if FC_Saved.Shards[name] and FC_Saved.Shards[name][2]==FC_Saved.Update and FC_Saved.Shards[name][3]~=FW.FLAG_OFFLINE and FW.Ranks[name] and FW.Ranks[name] > 0 and (not master or master<name or FW.Version[master]<FW.Version[name]) then
			master=name;
		end
	end
	return master;
end

function FW:ToGroup(msg)
	if not FW.Settings["OutputRaid"] then return; end
	if GetNumRaidMembers() > 0 then
		SendChatMessage(msg,"RAID");
	elseif GetNumPartyMembers() > 0 then
		SendChatMessage(msg,"PARTY");
	else
		FW:Show(msg);
	end

end

function FW:ToChannel(msg)
	if not FW.Settings["Output"] then return; end
	if strlower(FW.Settings["OutputMsg"]) == "say" then
		SendChatMessage(msg,"SAY");
	else
		local index = tonumber(FW.Settings["OutputMsg"]) or GetChannelName(FW.Settings["OutputMsg"]);
		if index then
			SendChatMessage(msg,"CHANNEL",nil,index);
		end
	end
end

function FW:PlaySound(option)
	if FW.Settings[option.."Enable"] then
		for i=1,FW.Settings[option.."Volume"],1 do
			PlaySoundFile(FW.Settings[option]);
		end
	end
end

function FW:MixColors(v,c1,c2)
	-- v == 0 then color = c1, v == 1 then color = c2
	if v<0 then v=0; elseif v>1 then v=1;end
	return c1[1]*(1-v)+c2[1]*v,c1[2]*(1-v)+c2[2]*v,c1[3]*(1-v)+c2[3]*v;
end

function FW:MixColors2(v,c1r,c1g,c1b,c2r,c2g,c2b)
	-- v == 0 then color = c1, v == 1 then color = c2
	if v<0 then v=0; elseif v>1 then v=1;end
	return c1r*(1-v)+c2r*v,c1g*(1-v)+c2g*v,c1b*(1-v)+c2b*v;
end

function FW:Whisper(msg,to)
	SendChatMessage(msg,"WHISPER",nil,to);
end

function FW:Size(t)
	local i = 0;
	for k, v in pairs(t) do i=i+1;end
	return i;
end

function FW:DeleteProfile(name)
	if FC_Saved.Profiles[name] == nil then return; end
	
	for key, val in pairs(FC_Saved.Profiles) do -- do only if at least one other profile exists
		if key ~= name then
			FW:UseProfile(key);
			FC_Saved.Profiles[name]=nil;
			return;
		end
	end
end

function FW:CreateProfile(name)
	if FC_Saved.PROFILE == name then return;end
	
	if FC_Saved.Profiles[name] == nil then
		FC_Saved.Profiles[name] = {};
	else
		erase(FC_Saved.Profiles[name]);
	end
	FW_InitConfig2(FW.Settings,FC_Saved.Profiles[name]);
	
	FW:UseProfile(name);
end

function FW:UseProfile(name,onload)
	if FC_Saved.Profiles[name] == nil then -- make use i always load a profile!!!!
		for key, val in pairs(FC_Saved.Profiles) do
			name = key;
			break;
		end
	end
	FC_Saved.PROFILE = name;
	FC_Saved.PROFILES[FW:FullName()] = FC_Saved.PROFILE;
	FW.Settings = FC_Saved.Profiles[FC_Saved.PROFILE];
	FW_InitConfig2(FW.Default,FW.Settings);
	FW_InitFrameVars(); -- always do, since profiles may still need fixing
	FW_InitFramePositions(); -- always do, since profiles may still need fixing
	if not onload then
		FW:BuildOptions();
		FW:RefreshOptions();
	end	
	FW:RefreshFrames(); -- also updates the settings tables of clones, so make sure this is called before doing anything with them
	if not onload then
		FW_RefreshAllFilters();
	end
end

function FW:ShowTimeFor(spell,target,timeleft,iscooldown)
	if spell ~= target then -- really has a target
		if bit.band(1,FW.Settings.TimeLeft) ~= 0 then
			FW:ToGroup( string.format( FW.Settings.TimeLeftMsg,spell,target, FW:SecToTimeD(timeleft) ) );
		end
		if bit.band(2,FW.Settings.TimeLeft) ~= 0 then
			FW:ToChannel( string.format( FW.Settings.TimeLeftMsg,spell,target, FW:SecToTimeD(timeleft) ) );
		end
	else
		if iscooldown then
			if bit.band(1,FW.Settings.CooldownLeft) ~= 0 then
				FW:ToGroup( string.format( FW.Settings.CooldownLeftMsg,spell,FW:SecToTimeD(timeleft) ) );
			end
			if bit.band(2,FW.Settings.CooldownLeft) ~= 0 then
				FW:ToChannel( string.format( FW.Settings.CooldownLeftMsg,spell,FW:SecToTimeD(timeleft) ) );
			end
		else
			if bit.band(1,FW.Settings.TimeLeftNoTarg) ~= 0 then
				FW:ToGroup( string.format( FW.Settings.TimeLeftNoTargMsg,spell,FW:SecToTimeD(timeleft) ) );
			end
			if bit.band(2,FW.Settings.TimeLeftNoTarg) ~= 0 then
				FW:ToChannel( string.format( FW.Settings.TimeLeftNoTargMsg,spell,FW:SecToTimeD(timeleft) ) );
			end
		end
	end
end
---------------------------------------------------------------------------
-- template/option functions
---------------------------------------------------------------------------
local function FW_LoadedFunc()
	for i, f in ipairs(FW_Loaded) do
			f();
	end
end

local FW_Bindings = {};
function FW:RegisterButtonPress(bindingname,buttonname,button)
	table.insert(FW_Bindings, {bindingname,buttonname,button} );
end

local function FW_UpdateBindings()
	--FW:Show("update");
	if not InCombatLockdown() then
		for i,t in ipairs(FW_Bindings) do
			ClearOverrideBindings(_G[t[2]]);
		end
		for i,t in ipairs(FW_Bindings) do
			local b1,b2 = GetBindingKey(t[1]);
			if b1 then
				SetOverrideBindingClick(_G[t[2]], false, b1,t[2],t[3]);
			end
			if b2 then
				SetOverrideBindingClick(_G[t[2]], false, b2,t[2],t[3]);
			end
		end
	end
end
---------------------------------------------------------------------------
-- options & events
---------------------------------------------------------------------------

local function FC_RegisterEvents()
	-- time based events
	
	-- things to do at load (after load delay)
	FW:RegisterDelayedLoadEvent(FW_Scan);
	FW:RegisterDelayedLoadEvent(FW_RelevantSetBonus);
	FW:RegisterDelayedLoadEvent(FW_RelevantTalent);
	FW:RegisterDelayedLoadEvent(FW_RelevantGlyph);
	FW:RegisterDelayedLoadEvent(FW_RelevantStance);
	FW:RegisterDelayedLoadEvent(FW_PartyRaid);
	FW:RegisterDelayedLoadEvent(FW_MakeSpeccInfo);--doesnt work at load event
	
	FW:RegisterOnLeaveCombat(FW_InitFramePositions); -- this is just a 'backup' init
	
	-- things to do on update event
	FW:RegisterUpdatedEvent(FW_UpdateCore);
	
	FW:RegisterScan(FW_ShardScan);
	FW:RegisterScan(FW_HealthstoneScan);
	
	-- done when all addon variables are loaded
	FW:RegisterVariablesEvent(function()
		
		FW:RegisterTimedEvent("UpdateInterval",		FW_TimedRaidParty);
		FW:RegisterTimedEvent("UpdateInterval",		FW_Scan);
		
		FW:RegisterTimedEvent("UpdateInterval",		FW_TimedClearBuffers);
		FW:RegisterTimedEvent("Chill",				FW_ExecuteChill);
		
		FW_RegisterBlockReagent();
		
		FW:RegisterToEvent("PLAYER_TALENT_UPDATE",	FW_RelevantTalent);
		FW:RegisterToEvent("PLAYER_TALENT_UPDATE",	function() FW_MakeSpeccInfo(nil); end);
		FW:RegisterToEvent("PLAYER_TALENT_UPDATE",	function() FW_SendSpeccInfo(nil); end);
		
		FW:RegisterToEvent("UPDATE_SHAPESHIFT_FORM", FW_RelevantStance);
		--FW_MakeSpeccInfo();--doesnt work at load event
		--FW:RefreshFrames();
	end);
	FW:RegisterToEvent("UPDATE_BINDINGS",			FW_UpdateBindings);
	
	FW:RegisterToEvent("PLAYER_REGEN_ENABLED",		FW_LeaveCombat);
	FW:RegisterToEvent("PLAYER_REGEN_DISABLED",		FW_EnterCombat);
	FW:RegisterToEvent("PLAYER_ALIVE",				FW_Ress)
	FW:RegisterToEvent("PLAYER_UNGHOST",			FW_Ress);
	FW:RegisterToEvent("PLAYER_LEAVING_WORLD",		function() LeaveCombat = 1; end);
	FW:RegisterToEvent("UNIT_INVENTORY_CHANGED",	function() FW:RegisterChill(FW_RelevantSetBonus);end);

	FW:RegisterToEvent("VARIABLES_LOADED",			FW_Variables);
	FW:RegisterToEvent("INSPECT_TALENT_READY",		function() FW_MakeSpeccInfo(1); end);
	FW:RegisterToEvent("CHAT_MSG_ADDON",			FW_AddonMessage);
	
	FW:RegisterToEvent("PLAYER_ENTERING_WORLD", 	FW_LoadedFunc);
	
	FW:RegisterToEvent("UNIT_PET", function(event,arg1) if arg1 == "player" then FW:Changed("pet");end end);
	
	FW:RegisterToEvent("GLYPH_ADDED", 	FW_RelevantGlyph);
	FW:RegisterToEvent("GLYPH_REMOVED", FW_RelevantGlyph);
	FW:RegisterToEvent("GLYPH_UPDATED", FW_RelevantGlyph);
	
	FW:RegisterEnterPartyRaid( function(joined) if joined then FW_VersionCheck();end end );
	FW:RegisterEnterPartyRaid( function(joined) if joined then FW_GetSpeccInfo();end end );
end

local function FC_Load()
	SlashCmdList["FORTEXORCIST"] = function(msg)
		local s = strsplit(" ",msg);
		if Commands[s] then
			Commands[s]( strsub(msg,strlen(s)+2) );
		else
			FW:ToggleOptions();
		end
	end
	
	SLASH_FORTEXORCIST1 = "/fw";
	SLASH_FORTEXORCIST2 = "/fortewarlock";
	SLASH_FORTEXORCIST3 = "/fc";
	SLASH_FORTEXORCIST4 = "/forteclass";
	SLASH_FORTEXORCIST5 = "/fx";
	SLASH_FORTEXORCIST6 = "/fortexorcist";

	FC_UpdateFrame = CreateFrame("Frame");
	FC_UpdateFrame:SetScript("OnEvent", FC_OnEvent);
	FC_UpdateFrame:SetScript("OnUpdate", FC_OnUpdate);
	--FC_UpdateFrame:RegisterAllEvents(); -- for debugging only
	FC_RegisterEvents();
end

FW:AddCommand("commands",
	function()
		for k,v in pairs(Commands) do
			FW:Show(k,1,1,0);
		end
	end
);
FW:AddCommand("version",
	function()
		for k, v in pairs(FW.Version) do
			FW:Show(k..": "..v);
		end
	end
);
local function FW_ResetOptionsFrame()
	FWOptions:ClearAllPoints();
	FWOptions:SetPoint("CENTER",UIParent, "CENTER",0,0);
	FW.Settings["FWOptions"].x,FW.Settings["FWOptions"].y = FW:GetCenter(FWOptions);
	FW.Settings["FWOptions"].alpha = 1.0;
	FW.Settings["FWOptions"].lock = false;
	FW.Settings["FWOptions"].scale = 1.0;
	
	FW.Settings.OptionsColums = 2;

	FW:BuildOptions();
	FWOptions:Update();
	FW:RefreshOptions();
end

FW:AddCommand("position",FW_ResetOptionsFrame);
FW:AddCommand("reset",FW_ResetOptionsFrame);

FW:AddCommand("master",
	function()
		local master = FW:Master();
		if master then
			FW:Show("Master Warlock: "..master,1,1,0);
		else
			FW:Show("No Master Warlock available",1,1,0);
		end
	end
);
FW:AddCommand("debug",
	function()
		FW_Debug = not FW_Debug;
		if FW_Debug then
			FW:Show("fw debugging enabled",1,1,0);
		else
			FW:Show("fw debugging disabled",1,1,0);
		end
	end
);
FW:AddCommand("wowbuild",
	function()
		local version, build, date, tocversion = GetBuildInfo();
		FW:Show("version:"..version..", build:"..build..", date:"..date..", tocversion:"..tocversion);
	end
);

FW:RegisterMessage(FW.GET_SHARDS,
	function() 
		if FW.LastShardCheck + 5 < GetTime() then
			FW.LastShardCheck = GetTime();
			FW:CheckShards();
		end
	end,
nil);
FW:RegisterMessage(FW.GET_HEALTHSTONE,
	function() 
		if FW.LastHSCheck + 5 < GetTime() then
			FW.LastHSCheck = GetTime();
			FW:CheckHealthstone();
		end
	end,
nil);
FW:RegisterMessage(GET_VERSION,FW_SendVersion,nil);
FW:RegisterMessage(SEND_VERSION,
	function(m,f)
		FW.Version[f] = m;
	end,
nil);
FW:RegisterMessage(GET_SPECC,FW_SendSpeccInfo,nil);
FW:RegisterMessage(SEND_SPECC,
	function(m,f)
		local id = FW:NameToID(f);
		if id then
			local class = select(2,UnitClass(id));
			if not FC_Saved.Speccs[class] then
				FC_Saved.Speccs[class] = {};
			end
			FC_Saved.Speccs[class][f] =  m;
			FW:CreateHealthstoneTypes();
		end
	end,
nil);
FW:RegisterORAMessage("oRAV ",
	function(a1,a2,f)
		FC_Saved.GotORA[f] = 1;
		return 1;
	end,
nil);
FW:RegisterORAMessage("V ",
	function(a1,a2,f)
		if FC_Saved.GotORA[f] == nil then 
			FC_Saved.GotORA[f] = 0;
		end
		return 1;
	end,
nil);
-- reply to num healthstones no matter what modules i'm using
FW:RegisterORAMessage(FW.ORA_ITEM_REQUEST,
	function(a1,a2,f)
		a1=tonumber(a1);
		if a1 then
			for i=#FW.ID_HEALTHSTONE,1,-1 do
				if a1==FW.ID_HEALTHSTONE[i][1] then
					FW:SendHealthstone(i,GetItemCount(a1));
					return 1;
				end
			end
		end
	end,
nil);

FW.Default.OptionsFontLabelColor = {1,1,1};
FW.Default.OptionsFontInputColor = {1,1,1};

FW.Default.AnimationInterval = 0.04;
FW.Default.LoadDelay = 1;
FW.Default.UpdateInterval = 0.5;
FW.Default.Chill = 0.05;

FW.Default.AnimateScroll = true;

FW.Default.FrameSnapDistance = 5;
FW.Default.FrameDistance = 0;
FW.Default.FrameSnap = true;
--FW.Default.FrameAnchor = false;
FW.Default.OptionsColums = 2;
FW.Default.OptionsHeight = 440;

FW.Default.TimeFormat = true;
FW.Default.Texture = "Interface\\AddOns\\Forte_Core\\Textures\\Aluminium";

FW.Default.BlockShardReagent = false;
FW.Default.SafeBlockShardReagent = false;
FW.Default.RightClickOptions = true;
FW.Default.RightClickIconOptions = true;

FW.Default.OptionBackgroundColor = {0.40,0.40,0.40,0.90};
FW.Default.OptionHeaderColor = {0.20,0.20,0.20};

FW.Default.HealthstoneNumber = 3;
FW.Default.HealthstoneTopRank = true;

--FW.Default.Font = "Fonts\\FRIZQT__.TTF";
FW.Default.Font = "Interface\\AddOns\\Forte_Core\\Fonts\\GOTHIC.TTF";
FW.Default.FontSize = 11;
FW.Default.GlobalLock = false;
FW.Default.GlobalAlpha = 1.0;
FW.Default.GlobalScale = 1.0;

FW.Default.SparkColor = {1.00,1.00,1.00,1.00};
FW.Default.SparkEnable = false;

FW.Default.OutputRaid = true;
FW.Default.Output = true;
FW.Default.OutputMsg = "MyProChannel";

FW.Default.OptionsModuleColor = true;
FW.Default.Tips = true;

FW.Default.TimeLeft = 1; FW.Default.TimeLeftMsg = ">> %s on %s is fading in %s <<";
FW.Default.TimeLeftNoTarg = 1; FW.Default.TimeLeftNoTargMsg = ">> %s is fading in %s <<";
FW.Default.CooldownLeft = 1; FW.Default.CooldownLeftMsg = ">> %s is ready in %s <<";

FW.Default.GlobalFrameNames = false;

--[[FW.Default.Backdrop = {
	"Interface\\AddOns\\Forte_Core\\Textures\\Background",
	"Interface\\AddOns\\Forte_Core\\Textures\\Border",
	false,16,5,5
}]]
FW.Default.OptionsBackdrop = {
	"Interface\\AddOns\\Forte_Core\\Textures\\Background",
	"Interface\\AddOns\\Forte_Core\\Textures\\Border",
	false,16,5,5
}
FW.Default.OptionsHeaderBackdrop = {
	"Interface\\AddOns\\Forte_Core\\Textures\\Otravi",
	"None",
	false,16,1,1
}
FW.Default.OptionsSubHeaderBackdrop = {
	"Interface\\AddOns\\Forte_Core\\Textures\\Smooth",
	"None",
	false,16,2,2
}

function FW:MakeBackdrop(backdrop,bg,edge,tile,tilesize,edgesize)
	if not backdrop.insets then backdrop.insets = {}; end
	backdrop.bgFile = bg;
	backdrop.edgeFile = edge;
	backdrop.tile = tile;
	backdrop.tileSize = tilesize;
	backdrop.edgeSize = edgesize;
	backdrop.insets.left = edgesize;
	backdrop.insets.right = edgesize;
	backdrop.insets.top = edgesize;
	backdrop.insets.bottom = edgesize;
end

function FW:SetBackdrop(frame,bg,edge,tile,tilesize,edgesize)
	if not frame.backdrop then frame.backdrop = {}; end
	FW:MakeBackdrop(frame.backdrop,bg,edge,tile,tilesize,edgesize);
	frame:SetBackdrop(frame.backdrop);
end

FC_Load();