-- ForteXorcist v1.957 by Xus 13-01-2010

if FW.CLASS == "SHAMAN" then
	local FW = FW;
	local FWL = FW.L;
	local SH = FW:ClassModule("Shaman");

	if FW.Modules.Timer then
		--
		-- Spells
		-- spell, hastarget, duration, isdot, istype, reducedinpvp, texture, stacks
		-- istype: FW.DEFAULT	FW.SHARED FW.UNIQUE	FW.PET FW.POWERUP FW.CHARM FW.DEBUFF FW.DRAIN FW.HEAL FW.BUFF
		
		-- Elemental Spells
		FW:RegisterSpell(59684,	1,012,1,FW.DEFAULT) -- Flame Shock
			FW:RegisterSpellModGlph(59684, 41531, 1, 6); -- Glyph of Flame Shock
		FW:RegisterSpell(49236,	1,008,0,FW.DEFAULT); -- Frost Shock
		-- Enhancement Spells
		FW:RegisterSpell(31331,	0, 45,0,FW.PET); -- Feral Spirit
		FW:RegisterSpell(17364, 1, 12,0,FW.DEFAULT); -- Stormstrike
		-- Restoration Spells
		FW:RegisterSpell(16237, 1,015,0,FW.BUFF); -- Ancestral Fortitude
		FW:RegisterSpell(60014, 1,600,0,FW.BUFF); -- Earth Shield
		FW:RegisterSpell(52000, 1,012,0,FW.HEAL); -- Earthliving
		FW:RegisterSpell(29203, 1,015,0,FW.BUFF); -- Healing Way
		FW:RegisterSpell(61301, 1,012,0,FW.HEAL); -- Riptide
		
		FW:RegisterCooldown(60043,008); -- Lava Burst
		FW:RegisterCooldown(59159,045); -- Thunderstorm
		FW:RegisterCooldown(49271,006); -- Chain Lightning

		--[[
		for like tremor totem, and the cleansing totem
		magma totem too
		]]
		
		FW:RegisterTickSpeed(58734,2); -- Magma Totem
		--FW:RegisterTickSpeed(58582,2); -- Stoneclaw Totem
		
		--FW:RegisterTickSpeed( 8143,3); -- Tremor Totem
		
		--
		-- Buffs
		-- buffnam
		--
		FW:RegisterBuff(58060); -- Glyph of Renewed Life

		-- Elemental
		FW:RegisterBuff(30165); -- Elemental Devastation
		FW:RegisterBuff(56221); -- Lightning Shield

		-- Enhancement
		FW:RegisterBuff(53819); -- Maelstrom Weapon
		FW:RegisterBuff(30824); -- Shamanistic Rage
		FW:RegisterBuff(30811); -- Unleashed Rage

		-- Restoration
		FW:RegisterBuff(53390); -- Tidal Waves
		FW:RegisterBuff(34828); -- Water Shield

		-- Code to track totems
		local function SH_TotemUpdate(event,index)
			-- Fire = 1 Earth = 2 Water = 3 Air = 4
			local _, name, startTime, duration, icon = GetTotemInfo(index);
			local i = FW.ST:find(FW.LAST_TIMER_FLAG+index,6);
			if i then
				if name ~= "" then
					FW.ST:remove(i);
				else
					if FW.ST[i][1]-GetTime()<0.75 then
						FW:Fade(i,2);
					else
						FW:Fade(i,3);
					end
				end
			end
			if name ~= "" then
				name = select(3,strfind(name,"^(.+) [XVI]+$")) or name;
				FW.ST:insert(startTime+duration,0,duration,name,0,FW.LAST_TIMER_FLAG+index,icon,name,2,0,"none",0,FW.PRIOR_NONE,0,1,0,0,FW:GetFilterType(name,FW.LAST_TIMER_FLAG+index),0,startTime+duration,duration,1.0);
			end
		end
		FW:RegisterToEvent("PLAYER_TOTEM_UPDATE", SH_TotemUpdate);
		
		FW:AddTimerFlag("TotemFire");
		FW:AddTimerFlag("TotemEarth");
		FW:AddTimerFlag("TotemWater");
		FW:AddTimerFlag("TotemAir");
		
		FW:RegisterDelayedLoadEvent(function(self)
			for i=1,4,1 do
				SH_TotemUpdate(self,i);
			end
		end);
		
		FW:RegisterCasterBuffs();
		FW:RegisterMeleeBuffs();
		
		FW:SetMainCategory(FWL.SPELL_TIMER,FW.ICON_ST,3,"TIMER","Timer","Timer");
			FW:SetSubCategory(FWL.COLORING_FILTERING,FW.ICON_FILTER,7);
				FW:RegisterOption(FW.CO2,1,FW.NON,"Fire Totem",				"",	"TotemFire",	FW.TimerGroupEnable);	
				FW:RegisterOption(FW.CO2,1,FW.NON,"Earth Totem",			"",	"TotemEarth",	FW.TimerGroupEnable);	
				FW:RegisterOption(FW.CO2,1,FW.NON,"Water Totem",			"",	"TotemWater",	FW.TimerGroupEnable);	
				FW:RegisterOption(FW.CO2,1,FW.NON,"Air Totem",				"",	"TotemAir",		FW.TimerGroupEnable);	
		
		FW.Default.Timer.TotemFireColor = {1.00,0.37,0.00};
		FW.Default.Timer.TotemFireEnable = true;
		FW.Default.Timer.TotemEarthColor = {1.00,0.56,0.00};
		FW.Default.Timer.TotemEarthEnable = true;
		FW.Default.Timer.TotemWaterColor = {0.00,1.00,0.67};
		FW.Default.Timer.TotemWaterEnable = true;
		FW.Default.Timer.TotemAirColor = {0.00,1.00,1.00};
		FW.Default.Timer.TotemAirEnable = true;
	end

	if FW.Modules.Cooldown then
		FW:RegisterCasterPowerupCooldowns();
		FW:RegisterMeleePowerupCooldowns();
	end
end